
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Master.h"
#include "ArgsMasterStart.h"
#include "ArgsMasterStop.h"


using namespace qmf::mrg::grid;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Master::packageName  = string ("mrg.grid");
string  Master::className    = string ("master");
uint8_t Master::md5Sum[16]   =
    {0x19,0xc4,0xdf,0x5,0xc7,0x9f,0xba,0xff,0xe7,0x7a,0x5c,0x3d,0x43,0x7c,0xf2,0x6d};

Master::Master (ManagementAgent* _agent, Manageable* _core) :
    ManagementObject(_agent, _core)
{
    
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    Pool = "";
    System = "";
    Name = "";
    Machine = "";
    PublicNetworkIpAddr = "";
    MyAddress = "";
    RealUid = 0;
    MonitorSelfAge = 0;
    MonitorSelfCPUUsage = 0.;
    MonitorSelfImageSize = 0.;
    MonitorSelfRegisteredSocketCount = 0;
    MonitorSelfResidentSetSize = 0;
    MonitorSelfTime = 0;



}

Master::~Master ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Master::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Master::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (10); // Config Element Count
    buf.putShort       (6); // Inst Element Count
    buf.putShort       (2); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "CondorPlatform");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor platform string for the daemon's platform");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CondorVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor version string for the daemon's version");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "DaemonStartTime");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Number of nanoseconds since epoch when the daemon     was started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Pool");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "System");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Machine");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PublicNetworkIpAddr");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "MyAddress");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "RealUid");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "MonitorSelfAge");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfCPUUsage");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfImageSize");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfRegisteredSocketCount");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfResidentSetSize");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfTime");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    buf.put (ft);


    // Methods
    ft.clear();
    ft.setString (NAME,     "Start");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Subsystem");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "The component/subsystem to start: one of STARTD,    SCHEDD, COLLECTOR, NEGOTIATOR, KBDD or QUILL");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "Stop");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Subsystem");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "The component/subsystem to stop: one of STARTD,    SCHEDD, COLLECTOR, NEGOTIATOR, KBDD or QUILL");
    buf.put (ft);


}



void Master::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(CondorPlatform);
    buf.putShortString(CondorVersion);
    buf.putLongLong(DaemonStartTime);
    buf.putShortString(Pool);
    buf.putShortString(System);
    buf.putShortString(Name);
    buf.putShortString(Machine);
    buf.putShortString(PublicNetworkIpAddr);
    buf.putShortString(MyAddress);
    buf.putInt32(RealUid);

}

void Master::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(MonitorSelfAge);
    buf.putDouble(MonitorSelfCPUUsage);
    buf.putDouble(MonitorSelfImageSize);
    buf.putLong(MonitorSelfRegisteredSocketCount);
    buf.putLong(MonitorSelfResidentSetSize);
    buf.putLongLong(MonitorSelfTime);


    // Maintenance of hi-lo statistics


}

void Master::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "Start") {
        ArgsMasterStart ioArgs;
        inBuf.getShortString(ioArgs.i_Subsystem);
        status = coreObject->ManagementMethod (METHOD_START, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "Stop") {
        ArgsMasterStop ioArgs;
        inBuf.getShortString(ioArgs.i_Subsystem);
        status = coreObject->ManagementMethod (METHOD_STOP, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
