
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Scheduler.h"
#include "ArgsSchedulerSubmit.h"


using namespace qmf::mrg::grid;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Scheduler::packageName  = string ("mrg.grid");
string  Scheduler::className    = string ("scheduler");
uint8_t Scheduler::md5Sum[16]   =
    {0x30,0x43,0x75,0x70,0x96,0x88,0xd7,0x85,0x45,0xfe,0x48,0x96,0xa2,0x59,0x13,0xce};

Scheduler::Scheduler (ManagementAgent* _agent, Manageable* _core) :
    ManagementObject(_agent, _core)
{
    
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    Pool = "";
    System = "";
    JobQueueBirthdate = 0;
    MaxJobsRunning = 0;
    Machine = "";
    MyAddress = "";
    Name = "";
    PublicNetworkIpAddr = "";
    MonitorSelfAge = 0;
    MonitorSelfCPUUsage = 0.;
    MonitorSelfImageSize = 0.;
    MonitorSelfRegisteredSocketCount = 0;
    MonitorSelfResidentSetSize = 0;
    MonitorSelfTime = 0;
    NumUsers = 0;
    TotalHeldJobs = 0;
    TotalIdleJobs = 0;
    TotalJobAds = 0;
    TotalRemovedJobs = 0;
    TotalRunningJobs = 0;



}

Scheduler::~Scheduler ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Scheduler::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Scheduler::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (11); // Config Element Count
    buf.putShort       (12); // Inst Element Count
    buf.putShort       (1); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "CondorPlatform");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor platform string for the daemon's platform");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CondorVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor version string for the daemon's version");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "DaemonStartTime");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Number of nanoseconds since epoch when the daemon     was started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Pool");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "System");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "JobQueueBirthdate");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "MaxJobsRunning");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Machine");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "MyAddress");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PublicNetworkIpAddr");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "MonitorSelfAge");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfCPUUsage");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfImageSize");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfRegisteredSocketCount");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfResidentSetSize");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfTime");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "NumUsers");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalHeldJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalIdleJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalJobAds");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalRemovedJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalRunningJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);


    // Methods
    ft.clear();
    ft.setString (NAME,     "Submit");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Ad");
    ft.setInt    (TYPE,    TYPE_FTABLE);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Id");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "O");
    buf.put (ft);


}



void Scheduler::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(CondorPlatform);
    buf.putShortString(CondorVersion);
    buf.putLongLong(DaemonStartTime);
    buf.putShortString(Pool);
    buf.putShortString(System);
    buf.putLongLong(JobQueueBirthdate);
    buf.putLong(MaxJobsRunning);
    buf.putShortString(Machine);
    buf.putShortString(MyAddress);
    buf.putShortString(Name);
    buf.putShortString(PublicNetworkIpAddr);

}

void Scheduler::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(MonitorSelfAge);
    buf.putDouble(MonitorSelfCPUUsage);
    buf.putDouble(MonitorSelfImageSize);
    buf.putLong(MonitorSelfRegisteredSocketCount);
    buf.putLong(MonitorSelfResidentSetSize);
    buf.putLongLong(MonitorSelfTime);
    buf.putLong(NumUsers);
    buf.putLong(TotalHeldJobs);
    buf.putLong(TotalIdleJobs);
    buf.putLong(TotalJobAds);
    buf.putLong(TotalRemovedJobs);
    buf.putLong(TotalRunningJobs);


    // Maintenance of hi-lo statistics


}

void Scheduler::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "Submit") {
        ArgsSchedulerSubmit ioArgs;
        ioArgs.i_Ad.decode(inBuf);
        status = coreObject->ManagementMethod (METHOD_SUBMIT, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putShortString(ioArgs.o_Id);
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
